
% This function is called by a different function, "optimizeP_givenO", which
% itself is called by main Matlab program running imaging polarimetric self-calibration.
% 
% You are very welcome to use this code. For this, clearly acknowledge 
% the source of this code, and cite the paper that describes the algorithm:
% Y. Y. Schechner, "Self-Calibrating Imaging Polarimetry", 
% Proc. IEEE Int. Conference on Computational Photography (ICCP), 2015.
%
% (c) Copyright Yoav Schechner 2015. The matlab code is available for 
% non-commercial use and exploration.  For commercial use contact the
% author. The author is not liable for any damages or loss that might be 
% caused by use or connection to this code. 



function [tildeOneto,inversetildeOneto,Ineto_transpos]=object_matrices(subdata,Object_matrix)


num_of_pixels=size(subdata,2);
num_of_angles=size(subdata,1);

Itranpos=subdata';
Object_C=Object_matrix(1,:);
Object_A=Object_matrix(2:3,:);

Ctilda=repmat(Object_C',[1 num_of_angles]);
Itilda_transpos=Itranpos-Ctilda;
Itilda_transpos_cs=Itilda_transpos(:);
l=length(Itilda_transpos_cs);
Ineto_transpos=Itilda_transpos_cs(num_of_pixels+1 : l);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

Otilda=Object_A';

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

Nrows=num_of_pixels*num_of_angles-num_of_pixels;
Ncols=2*num_of_angles-2;

tildeOneto=zeros(Nrows,Ncols);
for angleind=1:(num_of_angles-1),
    urow=(angleind-1)*num_of_pixels+1;
    drow=angleind*num_of_pixels;
    lcol=(angleind-1)*2+1;
    rcol=angleind*2;    
    tildeOneto(urow:drow,lcol:rcol)=Otilda;
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

inversetildeOneto=pinv(tildeOneto);
